class
	AST_CAST_EXPRESSION

inherit
	AST_EXPRESSION
		rename
			type_binding as type
		end
	AST_UTILITIES

create
	make,
	make_from_antlr,
	make_copy

feature {NONE}

	make (a_type: AST_TYPE; a_expression: AST_EXPRESSION)
		require
			a_type /= Void and then a_type.parent = Void
			a_expression /= Void and then a_expression.parent = Void
		do
			a_type.parent := Current
			type := a_type
			a_expression.parent := Current
			expression := a_expression
		end

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_cast_expression
		do
			parent := init_parent

			node.children.start
			type := process_type (node.children.item, Current)
			node.children.forth
			expression := process_expression (node.children.item, Current)
		end

feature {ANY}

	type: AST_TYPE

	expression: AST_EXPRESSION

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_cast_expression (Current)
			if visit_children then
				visit_node (type, v)
				visit_node (expression, v)
			end
			v.end_visit_cast_expression (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			type := other.type.ast_twin
			type.parent := Current
			expression := other.expression.ast_twin
			expression.parent := Current
		end

invariant
	type /= Void
	expression /= Void

end
