class
	AST_PARENTHESIZED_EXPRESSION

inherit
	AST_EXPRESSION

create
	make,
	make_from_antlr,
	make_copy

feature {NONE}

	make (a_expression: AST_EXPRESSION)
		require
			a_expression /= Void and then a_expression.parent = Void
		do
			expression := a_expression
			expression.parent := Current
		end

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_parenthesized_expression
		do
			parent := init_parent
			expression := process_expression (node.children.first, Current)
		end

feature {ANY}

	expression: AST_EXPRESSION

	type_binding: AST_TYPE
		do -- don't use object once here, might change in the expression
			Result := expression.type_binding
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_parenthesized_expression (Current)
			if visit_children then
				visit_node (expression, v)
			end
			v.end_visit_parenthesized_expression (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			expression := other.expression.ast_twin
			expression.parent := Current
		end

invariant
	expression /= Void

end
