class
	AST_TYPEDEF_TYPE

inherit
	AST_TYPE
		redefine
			make_copy
		end

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_typedef_type
		do
			parent := init_parent
			identifier := node.children.first.token_text
		end

feature {ANY}

	identifier: STRING

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_typedef_type (Current)
			if visit_children then
				-- no children
			end
			v.end_visit_typedef_type (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			Precursor (other)
			identifier := other.identifier.twin
		end

feature {ANY} -- AST_TYPE

	is_equal_type (a_type: AST_TYPE): BOOLEAN
		do
			if attached {AST_TYPEDEF_TYPE} a_type as other_type then
				Result := identifier.is_equal (other_type.identifier)
			end
		end

invariant
	identifier /= Void and then not identifier.is_empty

end
