class
	CFG_EDGE

inherit
	DEFAULT_HASHABLE

create
	make

feature {NONE}

	make (a_from_block, a_to_block: CFG_BASIC_BLOCK; a_label: INTEGER_8)
		require
			a_from_block /= Void
			a_to_block /= Void
			a_label = Label_no_label or a_label = Label_true or a_label = Label_false
			a_from_block.out_edges.is_empty or else across a_from_block.out_edges as c all c.item.to_block /= a_to_block end
		do
			from_block := a_from_block
			to_block := a_to_block
			label := a_label

			a_from_block.out_edges.extend (Current)
			a_to_block.in_edges.extend (Current)
		ensure
			from_block = a_from_block
			to_block = a_to_block
			label = a_label
		end

feature {ANY}

	Label_no_label,
	Label_true,
	Label_false: INTEGER_8 = unique

feature {ANY}

	from_block, to_block: CFG_BASIC_BLOCK

	label: INTEGER_8

	remove
		do
			from_block.out_edges.remove (Current)
			to_block.in_edges.remove (Current)
		end

invariant
	from_block /= Void
	to_block /= Void
	label = Label_no_label or label = Label_true or label = Label_false

end
