class
	ALLOCA_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_function_call,
			visit_function_declaration,
			end_visit_function_declaration
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING
		do
			Result := "Transforming alloca"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_function_call (node: AST_FUNCTION_CALL)
		do
			-- `alloca(1234)' -> `l_aaf.new (1234)'
			if node.identifier_str /= Void and then node.identifier_str.is_equal ("__builtin_alloca") then
				replace_node (node, create {AST_EIFFEL_EXPRESSION}.make_mixed (
						<<"l_aaf.new (", node.parameters.first.ast_twin, ")">>,
						node.type_binding
					))
				needs_alloca_factory := True
			end
		end

	visit_function_declaration (node: AST_FUNCTION_DECLARATION): BOOLEAN
		do
			needs_alloca_factory := False
			Result := True
		end

	end_visit_function_declaration (node: AST_FUNCTION_DECLARATION)
		do
			if needs_alloca_factory then
				node.needs_alloca_factory := True
			end
			if node.orig_c_identifier.is_equal ("__builtin_alloca") then
				delete_node (node)
			end
		end

feature {NONE}

	needs_alloca_factory: BOOLEAN

end
