class
	EXPANDED_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_assignment_expression,
			end_visit_function_call
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING
		do
			Result := "Ensuring expanded behavior of structs and va_lists"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_assignment_expression (node: AST_ASSIGNMENT_EXPRESSION)
		do
			inspect
				node.type
			when C_op_assign then
				handle_expression (node.source)
			else
				log (node.type.out + " not supported")
			end
		end

	end_visit_function_call (node: AST_FUNCTION_CALL)
		do
			across node.parameters as c loop
				handle_expression (c.item)
			end
		end

feature {NONE}

	handle_expression (a_expression: AST_EXPRESSION)
		require
			a_expression /= Void
		do
			if
				attached {AST_TYPE} a_expression.type_binding as t and then
				(
					attached {AST_STRUCT_TYPE} t or
					(attached {AST_BASIC_TYPE} t as bt and then bt.type = Ast_bt_builtin_va_list)
				)
			then
				replace_node (a_expression, create {AST_EIFFEL_EXPRESSION}.make_mixed (<<
						create {AST_PARENTHESIZED_EXPRESSION}.make (a_expression.ast_twin),
						".twin"
					>>, t));
			end
		end

end
