class
	EXPRESSION_AS_INSTRUCTION_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			visit_function_call
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description : STRING
		do
			Result := "Transforming expressions that are used as instructions"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	visit_function_call (node: AST_FUNCTION_CALL): BOOLEAN
		do
			if
				attached {AST_FUNCTION_DECLARATION} node.declaration_binding as fd and then -- `CE_ROUTINE.call' otherwise
				attached {AST_EXPRESSION_STATEMENT} node.parent and then
				not (attached {AST_BASIC_TYPE} fd.return_type as basic_type and then basic_type.type = Ast_bt_void)
			then
				replace_node (node, create {AST_EIFFEL_EXPRESSION}.make_mixed (<<node.ast_twin, ".do_nothing">>, create {AST_BASIC_TYPE}.make (Ast_bt_void)))
			end
		end

end
