class
	STD_STREAM_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_variable_declaration,
			end_visit_variable_expression
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING
		do
			Result := "Replacing %"stdin%", %"stdout%" and %"stderr%" with the Eiffel equivalent"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_variable_declaration (node: AST_VARIABLE_DECLARATION)
		do
			if
				node.storage_class_specifiers.has (C_kw_extern) and
				(node.identifier.is_equal ("stdin") or
				node.identifier.is_equal ("stdout") or
				node.identifier.is_equal ("stderr"))
			then
				delete_node (node)
			end
		end

	end_visit_variable_expression (node: AST_VARIABLE_EXPRESSION)
		do
			if node.identifier.is_equal ("stdin") then
				replace_node (node, create {AST_EIFFEL_EXPRESSION}.make ("(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.input.file_pointer))", node.type_binding))
			elseif node.identifier.is_equal ("stdout") then
				replace_node (node, create {AST_EIFFEL_EXPRESSION}.make ("(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))", node.type_binding))
			elseif node.identifier.is_equal ("stderr") then
				replace_node (node, create {AST_EIFFEL_EXPRESSION}.make ("(create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.error.file_pointer))", node.type_binding))
			end
		end

end
