class
	AST_AGENT_VISITOR

inherit
	AST_VISITOR
		redefine
			default_create
		end

feature {NONE}

	default_create
		do
			create agents
		end

feature {ANY}

	agents: TUPLE [
			post_visit: PROCEDURE [ANY, TUPLE [AST_NODE]]

			visit_array_type: PREDICATE [ANY, TUPLE [AST_ARRAY_TYPE]]
			visit_assignment_expression: PREDICATE [ANY, TUPLE [AST_ASSIGNMENT_EXPRESSION]]
			visit_cast_expression: PREDICATE [ANY, TUPLE [AST_CAST_EXPRESSION]]
			visit_function_call: PREDICATE [ANY, TUPLE [AST_FUNCTION_CALL]]
			visit_function_declaration: PREDICATE [ANY, TUPLE [AST_FUNCTION_DECLARATION]]
			visit_if_statement: PREDICATE [ANY, TUPLE [AST_IF_STATEMENT]]
			visit_pointer_type: PREDICATE [ANY, TUPLE [AST_POINTER_TYPE]]
			visit_postfix_expression: PREDICATE [ANY, TUPLE [AST_POSTFIX_EXPRESSION]]
			visit_variable_expression: PREDICATE [ANY, TUPLE [AST_VARIABLE_EXPRESSION]]

			end_visit_assignment_expression: PROCEDURE [ANY, TUPLE [AST_ASSIGNMENT_EXPRESSION]]
			end_visit_cast_expression: PROCEDURE [ANY, TUPLE [AST_CAST_EXPRESSION]]
			end_visit_eiffel_expression: PROCEDURE [ANY, TUPLE [AST_EIFFEL_EXPRESSION]]
			end_visit_eiffel_jump_target: PROCEDURE [ANY, TUPLE [AST_EIFFEL_JUMP_TARGET]]
			end_visit_function_call: PROCEDURE [ANY, TUPLE [AST_FUNCTION_CALL]]
			end_visit_if_statement: PROCEDURE [ANY, TUPLE [AST_IF_STATEMENT]]
			end_visit_jump_statement: PROCEDURE [ANY, TUPLE [AST_JUMP_STATEMENT]]
			end_visit_switch_case: PROCEDURE [ANY, TUPLE [AST_SWITCH_CASE]]
			end_visit_switch_default: PROCEDURE [ANY, TUPLE [AST_SWITCH_DEFAULT]]
			end_visit_unary_expression: PROCEDURE [ANY, TUPLE [AST_UNARY_EXPRESSION]]
			end_visit_variable_declaration: PROCEDURE [ANY, TUPLE [AST_VARIABLE_DECLARATION]]
			end_visit_variable_expression: PROCEDURE [ANY, TUPLE [AST_VARIABLE_EXPRESSION]]
			end_visit_while_statement: PROCEDURE [ANY, TUPLE [AST_WHILE_STATEMENT]]
		]

feature {ANY}

	pre_visit (node: AST_NODE) do end

	post_visit (node: AST_NODE)
		do
			if attached agents.post_visit as tmp then
				tmp.call ([node])
			end
		end

feature {ANY}

	visit_array_type (node: AST_ARRAY_TYPE): BOOLEAN
		do
			if attached agents.visit_array_type as tmp then
				Result := tmp.item ([node])
			else
				Result := True
			end
		end

	visit_assembler_statement (node: AST_ASSEMBLER_STATEMENT): BOOLEAN do Result := True end
	visit_asm_operand (node: AST_ASM_OPERAND): BOOLEAN do Result := True end
	visit_attribute (node: AST_GCC_ATTRIBUTE): BOOLEAN do Result := True end
	visit_attribute_specifier (node: AST_GCC_ATTRIBUTE_SPECIFIER): BOOLEAN do Result := True end
	visit_basic_type (node: AST_BASIC_TYPE): BOOLEAN do Result := True end
	visit_bit_field (node: AST_BITFIELD): BOOLEAN do Result := True end
	visit_builtin_va_arg_call (node: AST_BUILTIN_VA_ARG_CALL): BOOLEAN do Result := True end
	visit_alignof_call (node: AST_ALIGNOF_CALL): BOOLEAN do Result := True end
	visit_initializer (node: AST_INITIALIZER): BOOLEAN do Result := True end

	visit_assignment_expression (node: AST_ASSIGNMENT_EXPRESSION): BOOLEAN
		do
			if attached agents.visit_assignment_expression as tmp then
				Result := tmp.item ([node])
			else
				Result := True
			end
		end

	visit_boolean_constant (node: AST_BOOLEAN_CONSTANT): BOOLEAN do Result := True end

	visit_cast_expression (node: AST_CAST_EXPRESSION): BOOLEAN
		do
			if attached agents.visit_cast_expression as tmp then
				Result := tmp.item ([node])
			else
				Result := True
			end
		end

	visit_character_constant (node: AST_CHARACTER_CONSTANT): BOOLEAN do Result := True end
	visit_compound_statement (node: AST_COMPOUND_STATEMENT): BOOLEAN do Result := True end
	visit_decimal_constant (node: AST_DECIMAL_CONSTANT): BOOLEAN do Result := True end
	visit_eiffel_expression (node: AST_EIFFEL_EXPRESSION): BOOLEAN do Result := True end
	visit_eiffel_jump (node: AST_EIFFEL_JUMP): BOOLEAN do Result := True end
	visit_eiffel_jump_target (node: AST_EIFFEL_JUMP_TARGET): BOOLEAN do Result := True end
	visit_eiffel_string_type (node: AST_EIFFEL_STRING_TYPE): BOOLEAN do Result := True end
	visit_eiffel_type (node: AST_EIFFEL_TYPE): BOOLEAN do Result := True end
	visit_enum_declaration (node: AST_ENUM_DECLARATION): BOOLEAN do Result := True end
	visit_enum_type (node: AST_ENUM_TYPE): BOOLEAN do Result := True end
	visit_expression_statement (node: AST_EXPRESSION_STATEMENT): BOOLEAN do Result := True end
	visit_floating_point_constant (node: AST_FLOATING_POINT_CONSTANT): BOOLEAN do Result := True end

	visit_function_call (node: AST_FUNCTION_CALL): BOOLEAN
		do
			if attached agents.visit_function_call as tmp then
				Result := tmp.item ([node])
			else
				Result := True
			end
		end

	visit_function_declaration (node: AST_FUNCTION_DECLARATION): BOOLEAN
		do
			if attached agents.visit_function_declaration as tmp then
				Result := tmp.item ([node])
			else
				Result := True
			end
		end

	visit_function_type (node: AST_FUNCTION_TYPE): BOOLEAN do Result := True end
	visit_generic_expression (node: AST_GENERIC_EXPRESSION): BOOLEAN do Result := True end
	visit_hex_constant (node: AST_HEX_CONSTANT): BOOLEAN do Result := True end

	visit_if_statement (node: AST_IF_STATEMENT): BOOLEAN
		do
			if attached agents.visit_if_statement as tmp then
				Result := tmp.item ([node])
			else
				Result := True
			end
		end

	visit_jump_statement (node: AST_JUMP_STATEMENT): BOOLEAN do Result := True end
	visit_labeled_statement (node: AST_LABELED_STATEMENT): BOOLEAN do Result := True end
	visit_octal_constant (node: AST_OCTAL_CONSTANT): BOOLEAN do Result := True end
	visit_parameter_list (node: AST_PARAMETER_LIST): BOOLEAN do Result := True end
	visit_parenthesized_expression (node: AST_PARENTHESIZED_EXPRESSION): BOOLEAN do Result := True end

	visit_pointer_type (node: AST_POINTER_TYPE): BOOLEAN
		do
			if attached agents.visit_pointer_type as tmp then
				Result := tmp.item ([node])
			else
				Result := True
			end
		end

	visit_postfix_expression (node: AST_POSTFIX_EXPRESSION): BOOLEAN
		do
			if attached agents.visit_postfix_expression as tmp then
				Result := tmp.item ([node])
			else
				Result := True
			end
		end

	visit_sizeof_expression (node: AST_SIZEOF_EXPRESSION): BOOLEAN do Result := True end
	visit_string_constant (node: AST_STRING_CONSTANT): BOOLEAN do Result := True end
	visit_struct_declaration (node: AST_STRUCT_DECLARATION): BOOLEAN do Result := True end
	visit_struct_type (node: AST_STRUCT_TYPE): BOOLEAN do Result := True end
	visit_switch_case (node: AST_SWITCH_CASE): BOOLEAN do Result := True end
	visit_switch_default (node: AST_SWITCH_DEFAULT): BOOLEAN do Result := True end
	visit_switch_statement (node: AST_SWITCH_STATEMENT): BOOLEAN do Result := True end
	visit_translation_unit (node: AST_TRANSLATION_UNIT): BOOLEAN do Result := True end
	visit_typedef_declaration (node: AST_TYPEDEF_DECLARATION): BOOLEAN do Result := True end
	visit_typedef_type (node: AST_TYPEDEF_TYPE): BOOLEAN do Result := True end
	visit_unary_expression (node: AST_UNARY_EXPRESSION): BOOLEAN do Result := True end
	visit_variable_declaration (node: AST_VARIABLE_DECLARATION): BOOLEAN do Result := True end

	visit_variable_expression (node: AST_VARIABLE_EXPRESSION): BOOLEAN
		do
			if attached agents.visit_variable_expression as tmp then
				Result := tmp.item ([node])
			else
				Result := True
			end
		end

	visit_while_statement (node: AST_WHILE_STATEMENT): BOOLEAN do Result := True end

feature {ANY}

	end_visit_array_type (node: AST_ARRAY_TYPE) do end
	end_visit_assembler_statement (node: AST_ASSEMBLER_STATEMENT) do end
	end_visit_asm_operand (node: AST_ASM_OPERAND) do end
	end_visit_attribute (node: AST_GCC_ATTRIBUTE) do end
	end_visit_attribute_specifier (node: AST_GCC_ATTRIBUTE_SPECIFIER) do end
	end_visit_basic_type (node: AST_BASIC_TYPE) do end
	end_visit_bit_field (node: AST_BITFIELD) do end
	end_visit_builtin_va_arg_call (node: AST_BUILTIN_VA_ARG_CALL) do end
	end_visit_alignof_call (node: AST_ALIGNOF_CALL) do end
	end_visit_initializer (node: AST_INITIALIZER) do end

	end_visit_assignment_expression (node: AST_ASSIGNMENT_EXPRESSION)
		do
			if attached agents.end_visit_assignment_expression as tmp then
				tmp.call ([node])
			end
		end

	end_visit_boolean_constant (node: AST_BOOLEAN_CONSTANT) do end

	end_visit_cast_expression (node: AST_CAST_EXPRESSION)
		do
			if attached agents.end_visit_cast_expression as tmp then
				tmp.call ([node])
			end
		end

	end_visit_character_constant (node: AST_CHARACTER_CONSTANT) do end
	end_visit_compound_statement (node: AST_COMPOUND_STATEMENT) do end
	end_visit_decimal_constant (node: AST_DECIMAL_CONSTANT) do end

	end_visit_eiffel_expression (node: AST_EIFFEL_EXPRESSION)
		do
			if attached agents.end_visit_eiffel_expression as tmp then
				tmp.call ([node])
			end
		end

	end_visit_eiffel_jump (node: AST_EIFFEL_JUMP) do end

	end_visit_eiffel_jump_target (node: AST_EIFFEL_JUMP_TARGET)
		do
			if attached agents.end_visit_eiffel_jump_target as tmp then
				tmp.call ([node])
			end
		end

	end_visit_eiffel_string_type (node: AST_EIFFEL_STRING_TYPE) do end
	end_visit_eiffel_type (node: AST_EIFFEL_TYPE) do end
	end_visit_enum_declaration (node: AST_ENUM_DECLARATION) do end
	end_visit_enum_type (node: AST_ENUM_TYPE) do end
	end_visit_expression_statement (node: AST_EXPRESSION_STATEMENT) do end
	end_visit_floating_point_constant (node: AST_FLOATING_POINT_CONSTANT) do end

	end_visit_function_call (node: AST_FUNCTION_CALL)
		do
			if attached agents.end_visit_function_call as tmp then
				tmp.call ([node])
			end
		end

	end_visit_function_declaration (node: AST_FUNCTION_DECLARATION) do end
	end_visit_function_type (node: AST_FUNCTION_TYPE) do end
	end_visit_generic_expression (node: AST_GENERIC_EXPRESSION) do end
	end_visit_hex_constant (node: AST_HEX_CONSTANT) do end

	end_visit_if_statement (node: AST_IF_STATEMENT)
		do
			if attached agents.end_visit_if_statement as tmp then
				tmp.call ([node])
			end
		end

	end_visit_jump_statement (node: AST_JUMP_STATEMENT)
		do
			if attached agents.end_visit_jump_statement as tmp then
				tmp.call ([node])
			end
		end

	end_visit_labeled_statement (node: AST_LABELED_STATEMENT) do end
	end_visit_octal_constant (node: AST_OCTAL_CONSTANT) do end
	end_visit_parameter_list (node: AST_PARAMETER_LIST) do end
	end_visit_parenthesized_expression (node: AST_PARENTHESIZED_EXPRESSION) do end
	end_visit_pointer_type (node: AST_POINTER_TYPE) do end
	end_visit_postfix_expression (node: AST_POSTFIX_EXPRESSION) do end
	end_visit_sizeof_expression (node: AST_SIZEOF_EXPRESSION) do end
	end_visit_string_constant (node: AST_STRING_CONSTANT) do end
	end_visit_struct_declaration (node: AST_STRUCT_DECLARATION) do end
	end_visit_struct_type (node: AST_STRUCT_TYPE) do end

	end_visit_switch_case (node: AST_SWITCH_CASE)
		do
			if attached agents.end_visit_switch_case as tmp then
				tmp.call ([node])
			end
		end

	end_visit_switch_default (node: AST_SWITCH_DEFAULT)
		do
			if attached agents.end_visit_switch_default as tmp then
				tmp.call ([node])
			end
		end

	end_visit_switch_statement (node: AST_SWITCH_STATEMENT) do end
	end_visit_translation_unit (node: AST_TRANSLATION_UNIT) do end
	end_visit_typedef_declaration (node: AST_TYPEDEF_DECLARATION) do end
	end_visit_typedef_type (node: AST_TYPEDEF_TYPE) do end

	end_visit_unary_expression (node: AST_UNARY_EXPRESSION)
		do
			if attached agents.end_visit_unary_expression as tmp then
				tmp.call ([node])
			end
		end

	end_visit_variable_declaration (node: AST_VARIABLE_DECLARATION)
		do
			if attached agents.end_visit_variable_declaration as tmp then
				tmp.call ([node])
			end
		end

	end_visit_variable_expression (node: AST_VARIABLE_EXPRESSION)
		do
			if attached agents.end_visit_variable_expression as tmp then
				tmp.call ([node])
			end
		end

	end_visit_while_statement (node: AST_WHILE_STATEMENT)
		do
			if attached agents.end_visit_while_statement as tmp then
				tmp.call ([node])
			end
		end

end
